mod Ex09a

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  9. CVIČENIE Z PREDMETU 1-INF-450 LOGIKA PRE INFORMATIKOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.20 
  \para* \it  Dátum:  \end streda 20.11.2013 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1314zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované 
  deklaratívnemu programovaniu a efektívnym operáciam na primitívne 
  rekurzívnych indexoch. Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor \it  mxprf.cl  \end obsahuje aritmetizáciu p.r. 
         funkčných symbolov. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 0 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 0 
  \end
  \para Odovzdať do 25.11.2013 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/2 Tex_f2_a
  Std('A',0)

appldisp/2 Tex_f2_ln_zip
  Std('Zip',0)

rem 
  \para \bf  [CL] Remark.  \end Below use the non-strict version of the function 
  \ft D \end from the module \it  Standard  \end; it plays the role of \it  
  if-then-else  \end construct. 

rem 
  \para \bf  Chapter. Declarative Programming.  \end 

rem 
  \para \bf  Section. The Realm of Discrimination.  \end 

rem 
  \para \bf  Discrimination on constant patterns.  \end 

rem 
  \para \bf  Exercise.  \end Find a simple closed form of the following clausal 
  definition: 

fun Fib1 'Tex_f1_n_fib'
  Fib1(0) = 0
  Fib1(1) = 1
  Fib1(n) = Fib1(n-1)+Fib1(n-2) <- n != 0 & n != 1

rem 
  \para \it  Solution.  \end 

fun Fib1_scf 'Tex_f1_n_fib'
  Fib1_scf(n) = Foo

rem 
  \para \bf  Dichotomy discrimination.  \end 

rem 
  \para \bf  Exercise.  \end Find a simple closed form of the following clausal 
  definition: 

fun/2 Max 'Tex_f2_n_max'
  Max(x,y) = x <- x >= y
  Max(x,y) = y <- x < y

rem 
  \para \it  Solution.  \end 

fun/2 Max_scf 'Tex_f2_n_max'
  Max_scf(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Find a simple closed form of the following clausal 
  definition: 

fun/2 Div 'Tex_f2_n_div'
  Div(x,y) = 0 <- y != 0 & x < y
  Div(x,y) = Div(x-y,y)+1 <- y != 0 & x >= y

rem 
  \para Note that by default 
  \eq* 
    Div(x,0) = 0
  \end

rem 
  \para \it  Solution.  \end 

fun/2 Div_scf 'Tex_f2_n_div'
  Div_scf(x,y) = Foo

rem 
  \para \bf  Trichotomy discrimination.  \end 

rem 
  \para \bf  Exercise.  \end Find a simple closed form of the following clausal 
  definition: 

fun/2 Gcd 'Tex_f2_n_gcd'
  Gcd(x,y) = Max(x,y) <- x = 0
  Gcd(x,y) = Max(x,y) <- x != 0 & y = 0
  Gcd(x,y) = Gcd(x,y-x) <- x != 0 & y != 0 & x < y
  Gcd(x,y) = x <- x != 0 & y != 0 & x = y
  Gcd(x,y) = Gcd(x-y,y) <- x != 0 & y != 0 & x > y

rem 
  \para \it  Solution.  \end 

fun/2 Gcd_scf 'Tex_f2_n_gcd'
  Gcd_scf(x,y) = Foo

rem 
  \para \bf  Discrimination on monadic patterns.  \end 

rem 
  \para \bf  Exercise.  \end Find a simple closed form of the following clausal 
  definition: 

fun/2 Exp 'Tex_f2_n_exp'
  Exp(x,0) = 1
  Exp(x,y+1) = x*Exp(x,y)

rem 
  \para \it  Solution.  \end 

fun/2 Exp_scf 'Tex_f2_n_exp'
  Exp_scf(x,y) = Foo

rem 
  \para \bf  Exercise.  \end Find a simple closed form of the following clausal 
  definition: 

fun/2 A 
  A(0,y) = y+1
  A(x+1,0) = A(x,1)
  A(x+1,y+1) = A(x,A(x+1,y))

rem 
  \para \it  Solution.  \end 

fun/2 A_scf 'Tex_f2_a'
  A_scf(x,y) = Foo

rem 
  \para \bf  Discrimination on pair patterns.  \end 

rem 
  \para \bf  Exercise.  \end Find a simple closed form of the following clausal 
  definition: 

fun Szp 'Tex_f1_pp_sz_p'
  Szp(0) = 0
  Szp(v,w) = Szp(v)+Szp(w)+1

rem 
  \para \it  Solution.  \end 

fun Szp_scf 'Tex_f1_pp_sz_p'
  Szp_scf(x) = Foo

rem 
  \para \bf  Exercise.  \end Find a simple closed form of the following clausal 
  definition: 

fun/2 Zip 
  Zip(0,0) = 0
  Zip((v1,w1),v2,w2) = (v1,v2),Zip(w1,w2)

rem 
  \para \it  Solution.  \end 

fun/2 Zip_scf 'Tex_f2_ln_zip'
  Zip_scf(x,y) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

